# Accumulate Transactions

- **Create Identity**
  - Create an ADI
  - Sponsored by an ADI or Lite Token Account
- **Create Token Account**
  - Create an ADI Token Account
  - Sponsored by an ADI
- **Token Exchange**
  - Send tokens from one account to another
  - Sponsored by a token account (ADI or Lite)
  - Recipient must be an account (ADI or Lite)
- **Create Signature Specification**
  - Create a Signature Specification
  - Sponsored by an ADI or key book
  - When sponsored by an ADI, creates an unbound SS
  - When sponsored by a key book, creates an SS bound to that key book
- **Create Signature Specification Group**
  - Create a Signature Specification Group
  - Sponsored by an ADI
  - Must be created with at least one unbound Signature Specification
- **Add Credits**
  - Spend ACME tokens to add credits to a signator
  - Sponsored by a token account (ADI or Lite) holding ACME tokens
  - Recipient must be a signator (Lite Token Account or Signature Specification)
- **Update Key Page**
  - Add, remove, or update a key in a key page
  - Sponsored by a key page
- **Create Data Account**
  - Create an ADI Data Account
  - Sponsored by an ADI
- **Write Data**
  - Write data to an ADI Data Account
  - Sponsored by an ADI Data Account
- **Write Data To**
  - Write data to a Lite Data Account
  - Sponsored by an ADI or Lite Token Account
- **Issue Tokens**
  - Issue tokens to a token account (ADI or Lite)
  - Sponsored by a Token Issuer
- **Burn Tokens**
  - Burn tokens from a token account (ADI or Lite)
  - Sponsored by a token account (ADI or Lite)

## Synthetic

- **Synthetic Create Chain**
  - Creates chains
  - Sponsor is ignored
- **Synthetic Write Data**
  - Writes data to a Lite Data Account
  - Sponsored by the Lite Data Account
  - Creates a Lite Data Account if the sponsor is a Lite Data Address with no corresponding account
- **Synthetic Deposit Tokens**
  - Deposits tokens into an account
  - Sponsored by a token account (ADI or Lite)
  - Creates a Lite Token Account if the sponsor is a Lite Token Address with no corresponding account
- **Synthetic Deposit Credits**
  - Deposits credits into a signator
  - Sponsored by a signator (Lite Token Account or Signature Specification)
- **Synthetic Burn Tokens**
  - Returns tokens to a Token Issuer's pool of available tokens
  - Sponsored by a Token Issuer
