// Code generated by gitlab.com/accumulatenetwork/core/schema. DO NOT EDIT.

package block

import (
	record "gitlab.com/accumulatenetwork/accumulate/pkg/types/record"
	"gitlab.com/accumulatenetwork/core/schema/pkg/binary"
	"gitlab.com/accumulatenetwork/core/schema/pkg/widget"
)

type blockID struct {
	ID   uint64
	Part uint64
}

var wblockID = widget.ForComposite(widget.Fields[blockID]{
	{Name: "id", ID: 1, Widget: widget.ForUint(func(v *blockID) *uint64 { return &v.ID })},
	{Name: "part", ID: 2, Widget: widget.ForUint(func(v *blockID) *uint64 { return &v.Part })},
}, widget.Identity[*blockID])

// Copy returns a copy of the blockID.
func (v *blockID) Copy() *blockID {
	if v == nil {
		return nil
	}
	var u = new(blockID)
	wblockID.CopyTo(u, v)
	return u
}

// EqualblockID returns true if V is equal to U.
func (v *blockID) Equal(u *blockID) bool {
	return wblockID.Equal(v, u)
}

// MarshalBinary marshals the blockID to bytes using [binary].
func (v *blockID) MarshalBinary() ([]byte, error) {
	return widget.MarshalBinary(v, wblockID)
}

// MarshalBinary marshals the blockID to a [binary.Encoder].
func (v *blockID) MarshalBinaryV2(enc *binary.Encoder) error {
	return wblockID.MarshalBinary(enc, v)
}

// UnmarshalBinary unmarshals the blockID from bytes using [binary].
func (v *blockID) UnmarshalBinary(b []byte) error {
	return widget.UnmarshalBinary(v, wblockID, b)
}

// UnmarshalBinary unmarshals the blockID from a [binary.Decoder].
func (v *blockID) UnmarshalBinaryV2(dec *binary.Decoder) error {
	return wblockID.UnmarshalBinary(dec, v)
}

type endBlockEntry struct {
}

var wendBlockEntry = widget.ForComposite(widget.Fields[endBlockEntry]{
	{Name: "type", ID: 1, Widget: widget.ForTag[*entryType]("type", (*endBlockEntry).Type)},
}, widget.Identity[*endBlockEntry])

func (endBlockEntry) Type() entryType { return entryTypeEndBlock }

// Copy returns a copy of the endBlockEntry.
func (v *endBlockEntry) Copy() *endBlockEntry {
	if v == nil {
		return nil
	}
	var u = new(endBlockEntry)
	wendBlockEntry.CopyTo(u, v)
	return u
}

// EqualendBlockEntry returns true if V is equal to U.
func (v *endBlockEntry) Equal(u *endBlockEntry) bool {
	return wendBlockEntry.Equal(v, u)
}

// MarshalBinary marshals the endBlockEntry to bytes using [binary].
func (v *endBlockEntry) MarshalBinary() ([]byte, error) {
	return widget.MarshalBinary(v, wendBlockEntry)
}

// MarshalBinary marshals the endBlockEntry to a [binary.Encoder].
func (v *endBlockEntry) MarshalBinaryV2(enc *binary.Encoder) error {
	return wendBlockEntry.MarshalBinary(enc, v)
}

// UnmarshalBinary unmarshals the endBlockEntry from bytes using [binary].
func (v *endBlockEntry) UnmarshalBinary(b []byte) error {
	return widget.UnmarshalBinary(v, wendBlockEntry, b)
}

// UnmarshalBinary unmarshals the endBlockEntry from a [binary.Decoder].
func (v *endBlockEntry) UnmarshalBinaryV2(dec *binary.Decoder) error {
	return wendBlockEntry.UnmarshalBinary(dec, v)
}

// TODO type entry interface {}

var wentry = widget.ForUnion[*entryType](
	"type",
	entry.Type,
	map[entryType]widget.UnionMemberFields[entry]{
		entryTypeStartBlock: &widget.UnionMember[entry, startBlockEntry]{
			Fields: wstartBlockEntry.Fields,
		},
		entryTypeRecord: &widget.UnionMember[entry, recordEntry]{
			Fields: wrecordEntry.Fields,
		},
		entryTypeEndBlock: &widget.UnionMember[entry, endBlockEntry]{
			Fields: wendBlockEntry.Fields,
		},
	},
	widget.Identity[*entry])

// copyEntry returns a copy of the entry.
func copyEntry(v entry) entry {
	var u entry
	wentry.CopyTo(&u, &v)
	return u
}

// equalEntry returns true if A and B are equal.
func equalEntry(a, b entry) bool {
	return wentry.Equal(&a, &b)
}

// unmarshalEntryBinary unmarshals a entry from bytes using [binary].
func unmarshalEntryBinary(b []byte) (entry, error) {
	var v entry
	err := widget.UnmarshalBinary(&v, wentry, b)
	return v, err
}

// unmarshalEntryBinary unmarshals a entry from a [binary.Decoder].
func unmarshalEntryBinaryV2(dec *binary.Decoder) (entry, error) {
	var v entry
	err := wentry.UnmarshalBinary(dec, &v)
	return v, err
}

type entryType uint64

const (
	entryTypeEndBlock   entryType = 3
	entryTypeRecord     entryType = 2
	entryTypeStartBlock entryType = 1
)

var wentryType = widget.ForEnum[*entryType](widget.Identity[*entryType])

// SetByName looks up a entryType by name.
func (v *entryType) SetByName(s string) (ok bool) {
	*v, ok = sentryType.ByName(s)
	return
}

// SetByValue looks up a entryType by value.
func (v *entryType) SetByValue(i int64) (ok bool) {
	*v, ok = sentryType.ByValue(i)
	return
}

// String returns the label or name of the entryType.
func (v entryType) String() string {
	return sentryType.String(v)
}

// MarshalBinary marshals the entryType to bytes using [binary].
func (v entryType) MarshalBinary() ([]byte, error) {
	return widget.MarshalBinary(&v, wentryType)
}

// MarshalBinary marshals the entryType to a [binary.Encoder].
func (v entryType) MarshalBinaryV2(enc *binary.Encoder) error {
	return wentryType.MarshalBinary(enc, &v)
}

// UnmarshalBinary unmarshals the entryType from bytes using [binary].
func (v *entryType) UnmarshalBinary(b []byte) error {
	return widget.UnmarshalBinary(v, wentryType, b)
}

// UnmarshalBinary unmarshals the entryType from a [binary.Decoder].
func (v *entryType) UnmarshalBinaryV2(dec *binary.Decoder) error {
	return wentryType.UnmarshalBinary(dec, v)
}

type fileHeader struct {
}

var wfileHeader = widget.ForComposite(widget.Fields[fileHeader]{}, widget.Identity[*fileHeader])

// Copy returns a copy of the fileHeader.
func (v *fileHeader) Copy() *fileHeader {
	if v == nil {
		return nil
	}
	var u = new(fileHeader)
	wfileHeader.CopyTo(u, v)
	return u
}

// EqualfileHeader returns true if V is equal to U.
func (v *fileHeader) Equal(u *fileHeader) bool {
	return wfileHeader.Equal(v, u)
}

// MarshalBinary marshals the fileHeader to bytes using [binary].
func (v *fileHeader) MarshalBinary() ([]byte, error) {
	return widget.MarshalBinary(v, wfileHeader)
}

// MarshalBinary marshals the fileHeader to a [binary.Encoder].
func (v *fileHeader) MarshalBinaryV2(enc *binary.Encoder) error {
	return wfileHeader.MarshalBinary(enc, v)
}

// UnmarshalBinary unmarshals the fileHeader from bytes using [binary].
func (v *fileHeader) UnmarshalBinary(b []byte) error {
	return widget.UnmarshalBinary(v, wfileHeader, b)
}

// UnmarshalBinary unmarshals the fileHeader from a [binary.Decoder].
func (v *fileHeader) UnmarshalBinaryV2(dec *binary.Decoder) error {
	return wfileHeader.UnmarshalBinary(dec, v)
}

type recordEntry struct {
	Key     *record.Key
	KeyHash [32]byte
	Length  int64
}

var wrecordEntry = widget.ForComposite(widget.Fields[recordEntry]{
	{Name: "type", ID: 1, Widget: widget.ForTag[*entryType]("type", (*recordEntry).Type)},
	{Name: "key", ID: 2, Widget: widget.ForValue(func(v *recordEntry) **record.Key { return &v.Key })},
	{Name: "keyHash", ID: 3, Widget: widget.ForHash(func(v *recordEntry) *[32]byte { return &v.KeyHash })},
	{Name: "length", ID: 4, Widget: widget.ForInt(func(v *recordEntry) *int64 { return &v.Length })},
}, widget.Identity[*recordEntry])

func (recordEntry) Type() entryType { return entryTypeRecord }

// Copy returns a copy of the recordEntry.
func (v *recordEntry) Copy() *recordEntry {
	if v == nil {
		return nil
	}
	var u = new(recordEntry)
	wrecordEntry.CopyTo(u, v)
	return u
}

// EqualrecordEntry returns true if V is equal to U.
func (v *recordEntry) Equal(u *recordEntry) bool {
	return wrecordEntry.Equal(v, u)
}

// MarshalBinary marshals the recordEntry to bytes using [binary].
func (v *recordEntry) MarshalBinary() ([]byte, error) {
	return widget.MarshalBinary(v, wrecordEntry)
}

// MarshalBinary marshals the recordEntry to a [binary.Encoder].
func (v *recordEntry) MarshalBinaryV2(enc *binary.Encoder) error {
	return wrecordEntry.MarshalBinary(enc, v)
}

// UnmarshalBinary unmarshals the recordEntry from bytes using [binary].
func (v *recordEntry) UnmarshalBinary(b []byte) error {
	return widget.UnmarshalBinary(v, wrecordEntry, b)
}

// UnmarshalBinary unmarshals the recordEntry from a [binary.Decoder].
func (v *recordEntry) UnmarshalBinaryV2(dec *binary.Decoder) error {
	return wrecordEntry.UnmarshalBinary(dec, v)
}

type recordLocation struct {
	Block     *blockID
	Offset    int64
	HeaderLen int64
	RecordLen int64
}

var wrecordLocation = widget.ForComposite(widget.Fields[recordLocation]{
	{Name: "block", ID: 1, Widget: widget.ForCompositePtr(wblockID.Fields, func(v *recordLocation) **blockID { return &v.Block })},
	{Name: "offset", ID: 2, Widget: widget.ForInt(func(v *recordLocation) *int64 { return &v.Offset })},
	{Name: "headerLen", ID: 3, Widget: widget.ForInt(func(v *recordLocation) *int64 { return &v.HeaderLen })},
	{Name: "recordLen", ID: 4, Widget: widget.ForInt(func(v *recordLocation) *int64 { return &v.RecordLen })},
}, widget.Identity[*recordLocation])

// Copy returns a copy of the recordLocation.
func (v *recordLocation) Copy() *recordLocation {
	if v == nil {
		return nil
	}
	var u = new(recordLocation)
	wrecordLocation.CopyTo(u, v)
	return u
}

// EqualrecordLocation returns true if V is equal to U.
func (v *recordLocation) Equal(u *recordLocation) bool {
	return wrecordLocation.Equal(v, u)
}

type startBlockEntry struct {
	blockID
}

var wstartBlockEntry = widget.ForComposite(widget.Fields[startBlockEntry]{
	{Name: "type", ID: 1, Widget: widget.ForTag[*entryType]("type", (*startBlockEntry).Type)},
	{ID: 2, Widget: widget.ForComposite(wblockID.Fields, func(v *startBlockEntry) *blockID { return &v.blockID })},
}, widget.Identity[*startBlockEntry])

func (startBlockEntry) Type() entryType { return entryTypeStartBlock }

// Copy returns a copy of the startBlockEntry.
func (v *startBlockEntry) Copy() *startBlockEntry {
	if v == nil {
		return nil
	}
	var u = new(startBlockEntry)
	wstartBlockEntry.CopyTo(u, v)
	return u
}

// EqualstartBlockEntry returns true if V is equal to U.
func (v *startBlockEntry) Equal(u *startBlockEntry) bool {
	return wstartBlockEntry.Equal(v, u)
}

// MarshalBinary marshals the startBlockEntry to bytes using [binary].
func (v *startBlockEntry) MarshalBinary() ([]byte, error) {
	return widget.MarshalBinary(v, wstartBlockEntry)
}

// MarshalBinary marshals the startBlockEntry to a [binary.Encoder].
func (v *startBlockEntry) MarshalBinaryV2(enc *binary.Encoder) error {
	return wstartBlockEntry.MarshalBinary(enc, v)
}

// UnmarshalBinary unmarshals the startBlockEntry from bytes using [binary].
func (v *startBlockEntry) UnmarshalBinary(b []byte) error {
	return widget.UnmarshalBinary(v, wstartBlockEntry, b)
}

// UnmarshalBinary unmarshals the startBlockEntry from a [binary.Decoder].
func (v *startBlockEntry) UnmarshalBinaryV2(dec *binary.Decoder) error {
	return wstartBlockEntry.UnmarshalBinary(dec, v)
}
